#!/usr/bin/perl

$| = 1;
# find out if it is windows OS
if ($^O eq 'MSWin32' || $ENV{'OS'} eq 'Windows_NT') {
      # this one for windows
      $dpath = "$ENV{'PATH_TRANSLATED'}";
      $dpath =~ s/\\ads\.pl$//g;
      $windows = 'Yes';
}else{
      # this one for unix type
      $dpath = "$ENV{'SCRIPT_FILENAME'}";
      $dpath =~ s/\/ads\.pl$//g;
      $windows = 'No';
}

push (@INC, "$dpath");
require "settings.pl";
require "var.pl";


use CGI;
use CGI::Carp qw( fatalsToBrowser );
$query = new CGI;

if ($query->param('action')) {
    if ($query->param('action') eq 'display') {
        &check_default;
        &get_banner;
        exit;
    }
    if ($query->param('action') eq 'click') {
        &get_location;
        exit;
    }
}
else {
    &results('no_content');
}
exit;


############################# SUB Routines ####################################

sub check_default {

    if (-e "$file_dir/defaultcount.txt") {
        open(CURNUM, "<$file_dir/defaultcount.txt ") or die "Can't open Default File";
        $num = <CURNUM>;
        close(CURNUM);
    }
    else {
        open(CREATE, ">$file_dir/defaultcount.txt ") or die "Can't Create $file_dir/defaultcount.txt";
        close(CREATE);
    }

$num++;

    if ($num eq $default_displayed) {
        $num = "0";
        $display_default_banner = 'yes';
    }
    
    open(NEWNUM, ">$file_dir/defaultcount.txt ") or die "Can't open Default File";
    print NEWNUM "$num";
    close(NEWNUM);

    
}

sub show_sponsor {

    open (SLIST, "< $file_dir/sponsors.txt") or die "Can't open Sponsor list";
    @members = <SLIST>;
    close SLIST;
    srand;
    $array = $members[int rand(@members)];
    @slink = split (/\;/, $array);
        $b_account = $slink[1];
        $r_account = $query->param('member');
        $sponsor = 'yes';
        &adjust_counts('b_display');
        &adjust_counts('r_display');
        &account_count;
        &display_banner;
}

sub get_banner {

    &CR_VAR;
    if ($display_default_banner eq 'yes') {
        $r_account = $query->param('member');
        &adjust_counts('r_display');
        &account_count;
        $adlink[0] = "default";
        $adlink[2] = $defaultbanner;
        &display_banner;
    }
    else {
        open (LIST, "< $file_dir/members.txt") or die "Can't open Members list";
        @members = <LIST>;
        close LIST;
        srand;
        $array = $members[int rand(@members)];
        @adlink = split (/\;/, $array);

        if ($adlink[4] < "1") {
            &show_sponsor;
        }
        elsif ($adlink[1] eq $query->param('member')){
            &show_sponsor;
        }
        else {
            $b_account = $adlink[0];
            $r_account = $query->param('member');
            $sponsor = 'no';
            &adjust_counts('b_display');
            &adjust_counts('r_display');
            &account_count;
            &display_banner;
        }
    }
}

sub get_location {

    $member_id = $query->param('page');
    
    if ($member_id eq "default") {
        $r_account = $query->param('member');
        &adjust_counts('r_click');
        $url = $defaulturl;
    print "Location: $url", "\n\n";
    }
    else {
    if ($query->param('sp')) {
    open (URLS, "< $file_dir/sponsors.txt") or die "Can't open Sponsor list";
    }
    else {
    open (URLS, "< $file_dir/members.txt") or die "Can't open Members list";
    }
    @accounts = <URLS>;
    foreach $account (@accounts) {
        chomp $account;
        ($rec_member_id, $rec_member_name, $rec_member_banner, $rec_member_url, $rec_member_credits, $rec_member_impressions, $rec_member_hits, $rec_member_displays, $rec_member_clickthroughs, $rec_member_pass, $rec_member_email) =
            split /;/, $account;
        if ($member_id eq $rec_member_id) {
            $url = $rec_member_url;
            $member_name = $rec_member_name
        }
    }
    close URLS;
        $b_account = $member_name;
        $r_account = $query->param('member');
        &adjust_counts('b_click');
        &adjust_counts('r_click');
    print "Location: $url", "\n\n";
    }
}

sub adjust_counts {
  local($adjust_counts) = @_;
    
  if ($adjust_counts eq 'b_display') {

    if ($sponsor eq 'yes') {
    open (DCOUNT, "+>> $file_dir/sponsorscount.txt") or die "Can't open Sponsors Count list";
        flock DCOUNT, 2;
        seek DCOUNT, 0, 0;
        @records = <DCOUNT>;
        @new_records = ();
        foreach $record (@records) {
            chomp $record;
            ($rec_member_name, $rec_member_impressions, $rec_member_hits) =
                split /;/, $record;
            if ($b_account eq $rec_member_name) {
                $new_member_impressions = $rec_member_impressions + 1;
                $new_record = "$b_account;$new_member_impressions;$rec_member_hits";
                $record = $new_record;
            }
                $record .= "\n";
                push @new_records, $record;
        }
        seek DCOUNT, 0, 0;
        truncate DCOUNT, 0;
        print DCOUNT @new_records;
        flock DCOUNT, 8;
        close DCOUNT;
    }
    else {
    open (DCOUNT, "+>> $file_dir/members.txt") or die "Can't open Members list";
        flock DCOUNT, 2;
        seek DCOUNT, 0, 0;
        @records = <DCOUNT>;
        @new_records = ();
        foreach $record (@records) {
            chomp $record;
            ($rec_member_id, $rec_member_name, $rec_member_banner, $rec_member_url, $rec_member_credits, $rec_member_impressions, $rec_member_hits, $rec_member_displays, $rec_member_clickthroughs, $rec_member_pass, $rec_member_email) =
                split /;/, $record;
            if ($b_account eq $rec_member_id) {
                $new_member_credits = $rec_member_credits - 1;
                $new_member_impressions = $rec_member_impressions + 1;
                $new_record = "$b_account;$rec_member_name;$rec_member_banner;$rec_member_url;$new_member_credits;$new_member_impressions;$rec_member_hits;$rec_member_displays;$rec_member_clickthroughs;$rec_member_pass;$rec_member_email";
                $record = $new_record;
            }
                $record .= "\n";
                push @new_records, $record;
        }
        seek DCOUNT, 0, 0;
        truncate DCOUNT, 0;
        print DCOUNT @new_records;
        flock DCOUNT, 8;
        close DCOUNT;
    }
    
  }
  
  if ($adjust_counts eq 'r_display') {

    open (RCOUNT, "+>> $file_dir/members.txt") or die "Can't open Members list";

        flock RCOUNT, 2;
        seek RCOUNT, 0, 0;
        @records = <RCOUNT>;
        @new_records = ();
        foreach $record (@records) {
            chomp $record;
            ($rec_member_id, $rec_member_name, $rec_member_banner, $rec_member_url, $rec_member_credits, $rec_member_impressions, $rec_member_hits, $rec_member_displays, $rec_member_clickthroughs, $rec_member_pass, $rec_member_email) =
                split /;/, $record;
            if ($r_account eq $rec_member_name) {
                $new_member_credits = $rec_member_credits + .5;
                $new_member_displays = $rec_member_displays + 1;
                $new_record = "$rec_member_id;$r_account;$rec_member_banner;$rec_member_url;$new_member_credits;$rec_member_impressions;$rec_member_hits;$new_member_displays;$rec_member_clickthroughs;$rec_member_pass;$rec_member_email";
                $record = $new_record;
            }
                $record .= "\n";
                push @new_records, $record;

        }
        seek RCOUNT, 0, 0;
        truncate RCOUNT, 0;
        print RCOUNT @new_records;
        flock RCOUNT, 8;
        close RCOUNT;
  }
  
  if ($adjust_counts eq 'b_click') {

    if ($query->param('sp')) {
    open (CCOUNT, "+>> $file_dir/sponsorscount.txt") or die "Can't open Sponsors Count list";
        flock CCOUNT, 2;
        seek CCOUNT, 0, 0;
        @records = <CCOUNT>;
        @new_records = ();
        foreach $record (@records) {
            chomp $record;
            ($rec_member_name, $rec_member_impressions, $rec_member_hits) =
                split /;/, $record;
            if ($b_account eq $rec_member_name) {
                $new_member_hits = $rec_member_hits + 1;
                $new_record = "$b_account;$rec_member_impressions;$new_member_hits";
                $record = $new_record;
            }
                $record .= "\n";
                push @new_records, $record;

        }
        seek CCOUNT, 0, 0;
        truncate CCOUNT, 0;
        print CCOUNT @new_records;
        flock CCOUNT, 8;
        close CCOUNT;

    }
    else {
    open (CCOUNT, "+>> $file_dir/members.txt") or die "Can't open Members list";
        flock CCOUNT, 2;
        seek CCOUNT, 0, 0;
        @records = <CCOUNT>;
        @new_records = ();
        foreach $record (@records) {
            chomp $record;
            ($rec_member_id, $rec_member_name, $rec_member_banner, $rec_member_url, $rec_member_credits, $rec_member_impressions, $rec_member_hits, $rec_member_displays, $rec_member_clickthroughs, $rec_member_pass, $rec_member_email) =
                split /;/, $record;
            if ($b_account eq $rec_member_id) {
                $new_member_hits = $rec_member_hits + 1;
                $new_record = "$b_account;$rec_member_name;$rec_member_banner;$rec_member_url;$rec_member_credits;$rec_member_impressions;$new_member_hits;$rec_member_displays;$rec_member_clickthroughs;$rec_member_pass;$rec_member_email";
                $record = $new_record;
            }
                $record .= "\n";
                push @new_records, $record;

        }
        seek CCOUNT, 0, 0;
        truncate CCOUNT, 0;
        print CCOUNT @new_records;
        flock CCOUNT, 8;
        close CCOUNT;
    }
  
  }
  
  if ($adjust_counts eq 'r_click') {

    open (RCCOUNT, "+>> $file_dir/members.txt") or die "Can't open Members list";
        flock RCCOUNT, 2;
        seek RCCOUNT, 0, 0;
        @records = <RCCOUNT>;
        @new_records = ();
        foreach $record (@records) {
            chomp $record;
            ($rec_member_id, $rec_member_name, $rec_member_banner, $rec_member_url, $rec_member_credits, $rec_member_impressions, $rec_member_hits, $rec_member_displays, $rec_member_clickthroughs, $rec_member_pass, $rec_member_email) =
                split /;/, $record;
            if ($r_account eq $rec_member_name) {
                $new_member_credits = $rec_member_credits + 1;
                $new_member_clickthroughs = $rec_member_clickthroughs + 1;
                $new_record = "$rec_member_id;$r_account;$rec_member_banner;$rec_member_url;$new_member_credits;$rec_member_impressions;$rec_member_hits;$rec_member_displays;$new_member_clickthroughs;$rec_member_pass;$rec_member_email";
                $record = $new_record;
            }
                $record .= "\n";
                push @new_records, $record;

        }
        seek RCCOUNT, 0, 0;
        truncate RCCOUNT, 0;
        print RCCOUNT @new_records;
        close RCCOUNT;

  }

}

sub account_count {
    $membercount=0;
    open (ACOUNT, "< $file_dir/members.txt") or die "Can't open Members list";
    @caccounts = <ACOUNT>;
        foreach $caccount (@caccounts){
            $membercount++;
        }
    close ACOUNT;
    if ($addcount) {
        $newmembercount = $membercount + $addcount;
        $membercount = $newmembercount;
    }
}

sub display_banner {

 
            print <<"(END HTML)";
Content-type: text/html

<html>

<head>
<META NAME="robots" CONTENT="NOFOLLOW,NOINDEX">
<style>
body{
border: 3px solid $border;
scrollbar-base-color:$scroll;
}

A.pFo:link         {color:$link; text-decoration:overline;}
A.pFo:visited      {color:$link; text-decoration:overline;}
A.pFo:active       {color:$link; text-decoration:overline;}
A.pFo:hover        {color:$link; text-decoration:overline;}

</style>
<title></title>
</head>

<body onload="top.window.focus()" bgcolor="$backround" link="$link" vlink="$link" alink="$link" topmargin="0" leftmargin="0" marginwidth="0" marginheight="0" text="$text"><table border="0" cellpadding="8" cellspacing="0" width="100%">
  <tr>
    <td width="50%">
<p>&nbsp;</p>
    </td>
    <td width="50%" align="right" valign="top">
<p><font size="2" face="Arial"><a class="pFo" href="javascript:parent.window.focus();top.window.close()"> close </a></font></p>
    </td>
  </tr>
  <tr>
    <td width="100%" colspan="2">
(END HTML)


    if ($sponsor eq 'yes') {
            print <<"(END HTML)";
<p align="center"><p align="center"><a target="_blank" href="$adsurl?action=click&member=$r_account&page=$slink[0]&sp=true">
<img border="0" src="$slink[2]" width="120" height="60"></a></p></td>
(END HTML)
    }
    else {
            print <<"(END HTML)";
<p align="center"><p align="center"><a target="_blank" href="$adsurl?action=click&member=$r_account&page=$adlink[0]">
<img border="0" src="$adlink[2]" width="120" height="60"></a></p></td>
(END HTML)
    }
    
            print <<"(END HTML)";
  </tr>
  <tr>
    <td width="100%" colspan="2">
<p align="center"><a target="_blank" href="$exchangeurl">$exchangename</a></p>
<p align="left">Webmasters,<br>
Add this cool popup to your website... Get thousands of hits on
your website for FREE!!!&nbsp; <a target="_blank" href="$exchangeurl">Click Here</a> for more details...</p>
<p align="left">1. $exchangename is completely FREE...</p>
<p align="left">2. Your 120x60 banner will be displayed this same way on <b>$membercount</b>
other websites!!!</p>
<p align="left">3. Every time the window pops up on your website you will earn
credits for additional hits on all the other members of $exchangename!!!</p>
    </td>
  </tr>
  <tr>
    <td width="100%" colspan="2" align="right">
    <p align="center"><font size="2">Powered By: <br>
    <a target="_blank" href="http://www.mhfmedia.com/pscripts">
    PopupEX</a></font><br>
&nbsp;</td>
  </tr>
  <tr>
    <td width="100%" colspan="2" align="right"><p><font size="2" face="Arial"><a class="pFo" href="javascript:parent.window.focus();top.window.close()"> close </a></font></p></td>
  </tr>
</table>
</body>

</html>

(END HTML)

}
                                
sub results {

    local($results) = @_;

    if ($results eq 'no_content') {
            print <<"(END HTML)";
Content-type: text/html

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<meta name="GENERATOR" content="Microsoft FrontPage 5.0">
<meta name="ProgId" content="FrontPage.Editor.Document">
<meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
<title>The Ultimate Banner Exchange System</title>
</head>

<body>

<p align="center">&nbsp;</p>

<p align="center">&nbsp;</p>

<p align="center"><font size="5" color="#0000FF">PopupEX Version 1.0</font></p>

<p align="center"><font face="Arial" size="4">Designed for Windows NT and UNIX
Platforms </font></p>
<p align="center">Download it at:<br>
<a href="http://www.mhfmedia.com/pscripts">http://www.mhfmedia.com/pscripts</a></p>
<p align="center">&nbsp;</p>

</body>

</html>

(END HTML)
    }
}





